# -*- coding: utf-8 -*-
"""
Created on Sun Apr 19 18:42:04 2020

@author: USER
"""

import numpy as np
from numpy import *
from scipy import stats
from scipy.integrate import odeint
import pylab as pl
import random
import math
import networkx as nx

N=10
H=np.zeros([N],float)
for i in range(0,N):
    H[i]=10000.
G=nx.barabasi_albert_graph(N,3)
A = nx.to_numpy_matrix(G)
A = np.array(A)

degree = A.sum(axis=1)
row_sums= A.sum(axis=1)
A1=A/row_sums[:,np.newaxis]

e_v_c=nx.eigenvector_centrality(G)
c_c=nx.closeness_centrality(G)
bet_c=nx.betweenness_centrality(G)
clu_c=nx.clustering(G)
clo=[]
bet=[]
clu=[]
for i in range(0,N):
    clo.append(c_c[i])
    bet.append(bet_c[i])
    clu.append(clu_c[i])
a=[]
for i in range(0,N):
    a.append(1./N)

a3=[x/np.sum(degree) for x in degree]
a5=[x/np.sum(clo) for x in clo]
a6=[x/np.sum(bet) for x in bet]
a7=[x/np.sum(clu) for x in clu]


B=np.random.uniform(0.02,0.05,N)
v=np.zeros([5,N],float)
v[1,:]=a[:]
v[2,:]=a3[:]
v[3,:]=a6[:]
v[4,:]=a7[:]


       
#f1 = lambda x:c0+c1*x
def f(y,t):
    dy = np.empty(5*N+1,float)
    s = y[0:5*N:5]
    e = y[1:5*N:5]
    i_s = y[2:5*N:5]
    h = y[3:5*N:5]
    r = y[4:5*N:5]
    k = y[50]
    S1 = np.dot(A1,s)
    S2 = np.dot(A1,e)
    S3 = np.dot(A1,i_s)
    #alpha = f1(k)
    for i in range(0,N):
        dy[5*i] = ((-B[i]*s[i]*i_s[i])/H[i] )+K*(S1[i]-s[i])
        dy[5*i+1] = ((B[i]*s[i]*i_s[i])/H[i]) -sigma*e[i] + K*(S2[i]- e[i])
        dy[5*i+2] = sigma*e[i] - (c0+(c1*R[i]*k))*i_s[i] + K*(S3[i] - i_s[i])
        dy[5*i+3] = (c0+(c1*R[i]*k))*i_s[i] - gamma*h[i] -delta*h[i]
        dy[5*i+4] = gamma*h[i]
    dy[50] = xi*(np.sum(i_s)) - ki*k
    return dy
i_peak=[] 
peak_av=[] 
std_av=[]  
for k in range(0,2):
    print(k)
    R=v[k]
    sigma=0.1
    delta=0.0
    gamma=0.07
    c0=0.01
    c1=0.0001
    tf = 3000
    xi = 0.02
    ki = 0.1
    K=0.05
    y0 = np.zeros(5*N+1,float)
    y0[0:5*N:5]=10000.
    y0[1:5*N+1:5]=0
    y0[2:5*N+2:5]=0
    y0[3:5*N+3:5]=0  
    y0[4:5*N+4:5]=0
    y0[0]=y0[20]=10000-20
    y0[1]=y0[21]=13
    y0[2]=y0[22]=7
    y0[3]=0.
    y0[4]=0.
    y0[50]=10
    t1= np.linspace(0, tf, tf*100)
    [sol1,info] = odeint(f,y0,t1,full_output=1,printmessg=1)


    i_1=[]
    for  i in range(0,N):
        i_1.append(np.max(sol1[:,5*i+2]))
  
    i_2=[]
    for i in range(0,tf*100):
        i_2.append(np.sum(sol1[i,2:5*N:5])/100000.)
    i_peak.append(np.max(i_2)) 
    i_3=(np.dot(A1,sol1[:,2:5*N:5].transpose()))
    i_4=K*(i_3[7,:]-sol1[:,37])
#    np.savetxt('coupling_term_10.txt',i_3)
    l=['without-kit','identical','degree','betweenness','clustering','optimal']
    markers=["kx","bo","gP","ms","yX",'r+']
    l2=['k--','b--','g--','m--','y--','r--']
    ind1=(0,50000,100000,150000,200000,250000,300000)
    ind2=(0,0.05,.1,.15,.2)
    pl.figure(1)
    ma_on=[0,20000,40000,60000,80000,100000,120000,140000,160000,180000,200000,220000,240000,260000,280000]
    pl.plot(i_2,l2[k])
    pl.plot(ma_on,i_2[0:300000:20000],markers[k],label=l[k])
    #pl.plot(i_2,label=l[k], )
    pl.xlabel('$t$',fontsize=15)
    pl.ylabel(r'$cum-inf$',fontsize=15)
    pl.xticks(ind1,('0','500','1000','1500','2000','2500','3000'),fontsize=15)
    #pl.yticks(ind2,('0','0.05','.1','.15','.2'),fontsize=15)
    pl.rcParams['axes.linewidth']=2
    pl.legend()
    pl.tight_layout()
#
    pl.figure(2)
    #ma_on=[0,20000,40000,60000,80000,100000,120000,140000,160000,180000,200000,220000,240000,260000,280000]
    pl.plot(i_4,l2[k])
    #pl.plot(degree,i_1,label=l[k])
    pl.plot(ma_on,i_4[0:300000:20000],markers[k],label=l[k])
    pl.xlabel('$t$',fontsize=15)
    pl.ylabel(r'$coupling-term$',fontsize=15)
    #pl.xticks(ind1,('0','500','1000','1500','2000','2500','3000'),fontsize=15)
    #pl.yticks(ind2,('0','.1','.2','.3'),fontsize=15)
    pl.rcParams['axes.linewidth']=2
    pl.legend()
    pl.tight_layout()
    del i_3
    del i_4
    

    
