# -*- coding: utf-8 -*-
"""
Created on Sat May 02 15:27:40 2020

@author: USER
"""

import numpy as np
from numpy import *
from scipy import stats
from scipy.integrate import odeint
import pylab as pl
import random
import math
import networkx as nx
#import seaborn as sns
import matplotlib.gridspec as gridspec


N=10000.
def f(y,t):
    dy = np.empty(6,float)
    s = y[0]
    e = y[1]
    i_s = y[2]
    h = y[3]
    r = y[4]
    k = y[5]
    #w = f1(k)
    dy[0] = ((-B*s*i_s)/N)
    dy[1] = ((B*s*i_s)/N) -sigma*e 
    dy[2] = sigma*e - (c0+c1*p*k)*i_s 
    dy[3] = (c0+c1*p*k)*i_s - gamma*h -delta*h
    dy[4] = gamma*h
    dy[5] = xi*i_s - ki*k
    return dy

B=0.05    
sigma=0.1
delta=0.0
gamma=0.07
c0=0.01
c1=0.0001
p=1
xi = 0.02
ki = 0.1

tf = 1000
y0 = np.zeros(6,float)
y0[0]=10000-5
y0[1]=3
y0[2]=2
y0[3]=0.
y0[4]=0.
y0[5]=1
t1= np.linspace(0, tf, tf*100 )
[sol1,info] = odeint(f,y0,t1,full_output=1,printmessg=1)
S=[x/N for x in sol1[:,0]]
E=[x/N for x in sol1[:,1]]
I=[x/N for x in sol1[:,2]]
H=[x/N for x in sol1[:,3]]
R=[x/N for x in sol1[:,4]]
K=[x/N for x in sol1[:,5]]

ind1=(0,50000,100000)
ind2=(0,0.25,.5,.75,1)
ind3=(0,40000,80000)
ind4=(0,0.2,0.4)
pl.figure(1)
#pl.plot(sol1[:,0], label=r'$S$',color='b',linewidth=3)
pl.plot(E, label=r'$E$',color='goldenrod',linewidth=3)
pl.plot(I,label=r'$I$',color='tomato',linewidth=3)
#pl.plot(sol1[:,3],label=r'$H$',color='brown',linewidth=3)
#pl.plot(sol1[:,4],label=r'$R$',color='g',linewidth=3)
pl.plot(K,label=r'$K$',color='navy',linewidth=3)
pl.xlabel(r'$t$',fontsize=30)
pl.ylabel(r'$ S,E,I,H,R$',fontsize=30)
pl.xticks(ind1,('0','500','1000'),fontsize=30)
#pl.yticks(ind3,('0','500','1000','1500'),fontsize=30)
pl.rcParams['axes.linewidth']=2
pl.tick_params(direction= 'in', length=7,width=3)
pl.legend(fontsize=18,frameon=False)
pl.tight_layout()    
#

pl.figure(2,figsize=(6,6))
#pl.plot(S, label=r'$S$',color='b',linewidth=3)
pl.plot(E, label=r'$E$',color='b',linewidth=3)
pl.plot(I,label=r'$I$',color='r',linewidth=3)
#pl.plot(H,label=r'$H$',color='brown',linewidth=3)
#pl.plot(R,label=r'$R$',color='g',linewidth=3)
#pl.plot(K,label=r'$K$',color='g',linewidth=3)
pl.xlabel(r'$t$',fontsize=35)
pl.ylabel(r'$ E,I$',fontsize=35)
pl.xticks(ind1,('0','500','1000'),fontsize=30)
pl.yticks(ind4,('0','0.2','0.4'),fontsize=30)
pl.rcParams['axes.linewidth']=2
pl.tick_params(direction= 'in', length=7,width=3)
pl.legend(fontsize=24,frameon=False)
pl.tight_layout() 
##ind3=(0,50,100,150,200)
pl.figure(3,figsize=(6,6))
pl.stackplot(t1,R,colors=['g'])
pl.stackplot(t1,S,colors=['b'])
pl.stackplot(t1,I,colors=['r'])
pl.stackplot(t1,H,colors=['brown'])
pl.stackplot(t1,E,colors=['orange'])
#pl.stackplot(t1,K,colors=['k'])
pl.xlabel(r'$t$',fontsize=30)
pl.ylabel(r'$ S,E,I,H,R$',fontsize=30)
pl.xticks(fontsize=25)
pl.yticks(fontsize=25)
pl.rcParams['axes.linewidth']=2
pl.tick_params(direction= 'in', length=7,width=3)
#pl.legend(fontsize=20,frameon=False)
pl.tight_layout() 





pl.figure(4,figsize=(6,6))
pl.plot(S, label=r'$S$',color='b',linewidth=3)
pl.plot(E, label=r'$E$',color='orange',linewidth=3)
pl.plot(I,label=r'$I$',color='r',linewidth=3)
pl.plot(H,label=r'$H$',color='brown',linewidth=3)
pl.plot(R,label=r'$R$',color='g',linewidth=3)
pl.plot(K,label=r'$K$',color='k',linewidth=3)
pl.xlabel(r'$t$',fontsize=35)
pl.ylabel(r'$ S,E,I,H,R,K$',fontsize=35)
pl.xticks(ind1,('0','500','1000'),fontsize=30)
pl.yticks(ind2,('0','0.25','0.5','0.75','1'),fontsize=30)
pl.rcParams['axes.linewidth']=2
pl.tick_params(direction= 'in', length=7,width=3)
pl.legend(fontsize=20,frameon=False)
pl.tight_layout() 


ind5=(0,0.01,0.02,0.03)
ind6=(0,0.02,0.04)
fig, ax1=pl.subplots(figsize=(6,6))
left,bottom,width,height =[0.65,0.4,0.25,0.25] 
ax2= fig.add_axes([left,bottom,width,height])
ax1.plot(S, label=r'$S$',color='b',linewidth=3) 
ax1.plot(E, label=r'$E$',color='orange',linewidth=3)
ax1.plot(I,label=r'$I$',color='r',linewidth=3)
ax1.plot(H,label=r'$H$',color='brown',linewidth=3)
ax1.plot(R,label=r'$R$',color='g',linewidth=3)
ax1.plot(K,label=r'$K$',color='k',linewidth=3)
#ax1.legend(fontsize=16,frameon=False)
ax2.plot(E,color='orange',linewidth=3)
ax2.plot(K,color='k',linewidth=3)
ax2.plot(I,color='r',linewidth=3)
ax1.set_xlabel(r'$t$',fontsize=35)
ax1.set_ylabel(r'$ S,E,I,H,R,K$',fontsize=35)
ax1.set_xticklabels(('0','200','400','600','800','1000'),fontsize=25)
ax1.set_yticklabels(('0','0.2','0.4','0.6','0.8','1'),fontsize=25)
ax1.tick_params(direction= 'in', length=7,width=3)
pl.xticks(ind3,('0','400','800'),fontsize=20)
pl.yticks(ind6,('0','0.02','0.04'),fontsize=20)
ax2.tick_params(direction= 'in', length=4,width=2)
pl.tight_layout() 


fig=pl.figure(figsize=(6,6))
gs= gridspec.GridSpec(10,12)
ax0 =pl.subplot(gs[6:10,5:9])
axx=pl.subplot(gs[5:6,5:9])
axy=pl.subplot(gs[6:10,9:10])
ax0.plot(S, label=r'$S$',color='b',linewidth=3) 
ax0.plot(E, label=r'$E$',color='orange',linewidth=3)
ax0.plot(I,label=r'$I$',color='r',linewidth=3)
ax0.plot(H,label=r'$H$',color='brown',linewidth=3)
ax0.plot(R,label=r'$R$',color='g',linewidth=3)
ax0.plot(K,label=r'$K$',color='k',linewidth=3)
axx.plot(E,color='orange',linewidth=3)
axy.plot(K,color='k',linewidth=3)

ind7=(0,0.05,.1)
fig, ax1=pl.subplots(figsize=(6,6))
left,bottom,width,height =[0.65,0.34,0.25,0.25] 
ax2= fig.add_axes([left,bottom,width,height])
ax1.plot(S, label=r'$S$',color='b',linewidth=3) 
ax1.plot(E, label=r'$E$',color='orange',linewidth=3)
ax1.plot(I,label=r'$I$',color='r',linewidth=3)
ax1.plot(H,label=r'$H$',color='brown',linewidth=3)
ax1.plot(R,label=r'$R$',color='g',linewidth=3)
#ax1.legend(fontsize=16,frameon=False)
ax2.plot(E,color='orange',linewidth=3)
ax1.set_xlabel(r'$t$',fontsize=35)
ax1.set_ylabel(r'$ S,E,I,H,R$',fontsize=35)
ax1.set_xticklabels(('0','200','400','600','800','1000'),fontsize=25)
ax1.set_yticklabels(('0','0.2','0.4','0.6','0.8','1'),fontsize=25)
ax1.tick_params(direction= 'in', length=7,width=3)
pl.xticks(ind3,('0','400','800'),fontsize=20)
pl.yticks(ind7,('0','0.05','0.1'),fontsize=20)
ax2.tick_params(direction= 'in', length=4,width=2)
pl.tight_layout() 


pl.figure(8,figsize=(6,6))
