# -*- coding: utf-8 -*-
"""
Created on Wed Apr 28 21:36:50 2021

@author: subrata
"""

import numpy as np
from numpy import *
from scipy import stats
from scipy.integrate import odeint
import pylab as pl
import random
import math
import networkx as nx
#import seaborn as sns
import matplotlib.gridspec as gridspec

I1=np.loadtxt('infected_without_death.txt',float)

N=10000.
def f(y,t):
    dy = np.empty(6,float)
    s = y[0]
    e = y[1]
    i_s = y[2]
    h = y[3]
    r = y[4]
    k = y[5]
    #w = f1(k)
    dy[0] = ((-B*s*i_s)/N)
    dy[1] = ((B*s*i_s)/N) -sigma*e 
    dy[2] = sigma*e - (c0+c1*p*k)*i_s 
    dy[3] = (c0+c1*p*k)*i_s - gamma*h -delta*h
    dy[4] = gamma*h 
    dy[5] = xi*i_s - ki*k
    return dy

B=0.05    
sigma=0.1
delta=0.01
gamma=0.07
c0=0.01
c1=0.0001
p=1
xi = 0.02
ki = 0.1

tf = 1000
y0 = np.zeros(6,float)
y0[0]=10000-5
y0[1]=3
y0[2]=2
y0[3]=0.
y0[4]=0.
y0[5]=1
t1= np.linspace(0, tf, tf*100 )
[sol1,info] = odeint(f,y0,t1,full_output=1,printmessg=1)
N1=[]
for i in range(0,100000):
    N1.append(np.sum(sol1[i,0:5]))
#S=[x/N for x in sol1[:,0]]
#E=[x/N for x in sol1[:,1]]
#I=[x/N for x in sol1[:,2]]
#H=[x/N for x in sol1[:,3]]
#R=[x/N for x in sol1[:,4]]
#K=[x/N for x in sol1[:,5]]
I=[]
S=[]
for j in range(0,100000):
    I.append(sol1[j,2]/N1[j])
    S.append(sol1[j,0]/N1[j])

ind1=(0,50000,100000)
ind2=(0,0.25,.5,.75,1)
ind3=(0,40000,80000)
ind4=(0,0.2,0.4)
   
#

pl.figure(2,figsize=(6,6))

pl.plot(I,label=r'$I_{d}$',color='r',linewidth=3)
pl.plot(I1,label=r'$I$',color='brown',linewidth=3)
pl.xlabel(r'$t$',fontsize=35)
pl.ylabel(r'$ I$',fontsize=35)
pl.xticks(ind1,('0','500','1000'),fontsize=30)
pl.yticks(ind4,('0','0.2','0.4'),fontsize=30)
pl.rcParams['axes.linewidth']=2
pl.tick_params(direction= 'in', length=7,width=3)
pl.legend(fontsize=24,frameon=False)
pl.tight_layout() 
##ind3=(0,50,100,150,200)
