# -*- coding: utf-8 -*-
"""
Created on Fri Aug 07 19:08:29 2020

@author: subrata
"""

import numpy as np
from numpy import *
from scipy import stats
from scipy.integrate import odeint
import pylab as pl
import random
import math
import pandas as pd
import networkx as nx
from scipy import optimize

R0=np.arange(0.0,10,.05)
N=10000.
#a=0.01/(0.01+0.0001*(500*(0.02/0.1)))
#a0=np.zeros([len(R0)],float)
#for i in range(0,40):
#    a0[i]=0.6
#for j in range(40,100):
#    a0[j]=0.5
#for k in range(100,140):
#    a0[k]=0.4
#for i in range(140,199):
#    a0[i]=0.3  
u=np.arange(300,600,1.5)
a0=[x/100. for x in u]
a0=[x/1000. for x in u]
a0.reverse()  
    
def newton(f,Df,x0,epsilon,max_iter):
    xn=x0
    for n in range(0,max_iter):
        fxn = f(xn,h)
        if abs(fxn) < epsilon:
            return xn
        Dfxn = Df(xn,h)
        if Dfxn == 0:
            return None
        xn = xn - fxn/Dfxn
    return None
    
def f(x,h):
    return 1 - x - np.exp(-h*x)
    
def Df(x,h):
    return -1 + h*np.exp(-h*x)     



def g(y,t):
    dy = np.empty(6,float)
    s = y[0]
    e = y[1]
    i_s = y[2]
    h = y[3]
    r = y[4]
    k = y[5]
    #w = f1(k)
    dy[0] = ((-B*s*i_s)/N)
    dy[1] = ((B*s*i_s)/N) -sigma*e 
    dy[2] = sigma*e - (c0+c1*p*k)*i_s 
    dy[3] = (c0+c1*p*k)*i_s - gamma*h -delta*h
    dy[4] = gamma*h
    dy[5] = xi*i_s - ki*k
    return dy
    
#f = lambda x: 1 - x - np.exp(-h*x)
#Df = lambda x: -1 + h*np.exp(-h*x)


b=[x*0.1 for x in R0]
os_n=[]
os_t=[]  
for i in range(0,len(b)):
    B=b[i]   
    sigma=0.1
    delta=0.0
    gamma=0.07
    c0=0.1
    c1=0.0001
    p=0
    xi = 0.02
    ki = 0.1
    tf = 1000
    y0 = np.zeros(6,float)
    y0[0]=10000-5
    y0[1]=3
    y0[2]=2
    y0[3]=0.
    y0[4]=0.
    y0[5]=1
    t1= np.linspace(0, tf, tf*100 )
    [sol1,info] = odeint(g,y0,t1,full_output=1,printmessg=1)
    os_n.append(sol1[-1,4]/N)

    h=R0[i]
    a=a0[i]
    approx = newton(f,Df,0.5,1e-3,100)
    #root = optimize.newton(f,1,fprime=Df)
    os_t.append(approx)
ind1=(0,2.5,5,7.5,10)
ind2=(0,0.25,0.5,.75,1)
ind3=(0,0.25,0.5,0.75,1,1.02)
pl.figure(1)
pl.plot(R0,os_n, label=r'$Simulation$',color='b')
pl.plot(R0,os_t,"rs", label=r'$Theory$')
pl.xlabel(r'$R_{0}$',fontsize=30)
pl.ylabel(r'$ Z_{FOS}$',fontsize=30)
pl.xticks(ind1,('0','5','10'),fontsize=30)
pl.yticks(ind2,('0','0.5','1'),fontsize=30)
pl.rcParams['axes.linewidth']=2
pl.tick_params(direction= 'in', length=7,width=3)
pl.legend(fontsize=18)
pl.tight_layout() 

pl.figure(2)
pl.plot(R0,os_n, label=r'$Simulation$',color='b',linewidth=5)
pl.plot(R0,os_t,"rs", label=r'$Theory$')
pl.xlabel(r'$R_{0}$',fontsize=35)
pl.ylabel(r'$ Z_{FOS}$',fontsize=35)
pl.xticks(ind1,('0','2.5','5','7.5','10'),fontsize=35)
pl.yticks(ind3,('0','0.25','0.5','0.75','1',''),fontsize=35)
pl.rcParams['axes.linewidth']=2
pl.tick_params(direction= 'in', length=7,width=3)
pl.tick_params(which='minor',direction= 'in', length=3,width=2)
pl.legend(loc='lower right',fontsize=30)
pl.tight_layout()