# -*- coding: utf-8 -*-
"""
Created on Thu Aug 06 18:57:39 2020

@author: subrata
"""

import numpy as np
from numpy import *
from scipy import stats
from scipy.integrate import odeint
import pylab as pl
import random
import math
import networkx as nx
from scipy import optimize


N=10000.

R0=np.arange(0.0,6,.3)
r=np.arange(2,10,.3)
r1=np.zeros([len(r)+2],float)
r1[0]=0.
r1[1]=1.
for i in range(2,len(r1)):
    r1[i]=r[i-2]

    
def newton(f,Df,x0,epsilon,max_iter):
    xn=x0
    for n in range(0,max_iter):
        fxn = f(xn,h,a)
        if abs(fxn) < epsilon:
            return xn
        Dfxn = Df(xn,h,a)
        if Dfxn == 0:
            return None
        xn = xn - fxn/Dfxn
    return None
    
def f(x,h,a):
    return 1 - x - np.exp(-a*h*x)
    
def Df(x,h,a):
    return -1 + a*h*np.exp(-a*h*x)     



def g(y,t):
    dy = np.empty(6,float)
    s = y[0]
    e = y[1]
    i_s = y[2]
    h = y[3]
    r = y[4]
    k = y[5]
    #w = f1(k)
    dy[0] = ((-B*s*i_s)/N)
    dy[1] = ((B*s*i_s)/N) -sigma*e 
    dy[2] = sigma*e - (c0+c1*p*k)*i_s 
    dy[3] = (c0+c1*p*k)*i_s - gamma*h -delta*h
    dy[4] = gamma*h
    dy[5] = xi*i_s - ki*k
    return dy
    
#f = lambda x: 1 - x - np.exp(-h*x)
#Df = lambda x: -1 + h*np.exp(-h*x)


b=[x*0.01 for x in R0]
os_n=[]
os_t=[]  
for i in range(0,len(b)):
    B=b[i]   
    sigma=0.1
    delta=0.0
    gamma=0.07
    c0=0.01
    c1=0.0001
    p=1
    xi = 0.02
    ki = 0.1
    tf = 1000
    y0 = np.zeros(6,float)
    y0[0]=10000-5
    y0[1]=3
    y0[2]=2
    y0[3]=0.
    y0[4]=0.
    y0[5]=1
    t1= np.linspace(0, tf, tf*100 )
    [sol1,info] = odeint(g,y0,t1,full_output=1,printmessg=1)
    os_n.append(sol1[-1,4]/N)

#    h=R0[i]
#    a=a0[i]
#    approx = newton(f,Df,0.5,1e-3,100)
#    os_t.append(approx)

u=np.arange(300,750,10)
#a0=[x/100. for x in u]
a0=[x/1000. for x in u]
#a0.reverse() 
os_t=[]     
for i in range(0,len(u)):
    a=a0[i]
    o_t=[]
    for j in range(0,len(b)):
        h=R0[j]
        root=newton(f,Df,0.5,1e-3,100)
        o_t.append(root)
    os_t.append(o_t)
O=[]
for i in range(0,len(b)):
    O.append([])
    for j in range(0,len(u)):
        O[i].append(os_t[j][i])
S=[]
for i in range(0,len(b)):
    S.append(np.mean(O[i]))
ind1=(0,2,4,6)
ind2=(0,.2,.4,.6,.8,1)
pl.figure(1,figsize=(6,6))
for i in range(0,len(u)):
    pl.plot(R0,os_t[i],color='salmon',linewidth=20)
pl.plot(R0,os_n, color='orangered',linewidth=5)
pl.plot(R0,S, color='black',linewidth=4)    
pl.xlabel(r'$\mathcal{R_{0}}$',fontsize=30)
pl.ylabel(r'$Z_{FOS}$',fontsize=30)
pl.xticks(ind1,('0','2','4','6'),fontsize=30)
pl.yticks(ind2,('0','0.2','0.4','0.6','0.8','1'),fontsize=30)
pl.rcParams['axes.linewidth']=2
pl.tick_params(direction= 'in', length=10,width=5)
pl.tick_params(which='minor',direction= 'in', length=5,width=2)
#pl.legend(loc='upper left',fontsize=24,frameon=False)
pl.tight_layout() 

pl.figure(2,figsize=(6,6))
for i in range(0,len(u)):
    pl.plot(R0,os_t[i],color='pink',linewidth=20)
pl.plot(R0,os_n, color='orangered',linewidth=5)    
pl.xlabel(r'$\mathcal{R_{0}}$',fontsize=30)
pl.ylabel(r'$Z_{FOS}$',fontsize=30)
pl.xticks(ind1,('0','2','4','6'),fontsize=30)
pl.yticks(ind2,('0','0.2','0.4','0.6','0.8','1'),fontsize=30)
pl.rcParams['axes.linewidth']=2
pl.tick_params(direction= 'in', length=10,width=5)
pl.tick_params(which='minor',direction= 'in', length=5,width=2)
#pl.legend(loc='upper left',fontsize=24,frameon=False)
pl.tight_layout() 

pl.figure(3,figsize=(6,6))
pl.plot(R0,os_n, color='orangered',linewidth=5)
#pl.plot(R0,S, color='black',linewidth=4) 
pl.scatter(R0,S,s=150,color='none',edgecolors='salmon',linewidths=3)   
pl.xlabel(r'$\mathcal{R_{0}}$',fontsize=30)
pl.ylabel(r'$Z_{FOS}$',fontsize=30)
pl.xticks(ind1,('0','2','4','6'),fontsize=30)
pl.yticks(ind2,('0','0.2','0.4','0.6','0.8','1'),fontsize=30)
pl.rcParams['axes.linewidth']=2
pl.tick_params(direction= 'in', length=10,width=5)
pl.tick_params(which='minor',direction= 'in', length=5,width=2)
#pl.legend(loc='upper left',fontsize=24,frameon=False)
pl.tight_layout()      

Y=[]
for i in range(0,len(S)):
    Y.append([R0[i],S[i]])